/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.email.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="EMAIL.CountEmailVorgangAndStatusIn",
     query="select count(o) from Email o where o.emailVorgang=?1 and o.status in (?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.CountEmailVorgangAndStatus",
     query="select count(o) from Email o where o.emailVorgang=?1 and o.status=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.CountStatus",
     query="select count(o) from Email o where o.emailVorgang.wahltermin.mandant=?1 AND o.status=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.SendeversucheStatusAndFehlermeldungById",
     query="UPDATE Email o SET o.letzterSendeversuch = ?2, o.anzahlSendeversuche = ?3, o.status = ?4, o.fehlermeldung = ?5 WHERE o.id = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.StatusAndFehlermeldungByEmailVorgangAndStatus",
     query="UPDATE Email o SET o.status = ?3, o.fehlermeldung = ?4 WHERE o.emailVorgang = ?1 AND o.status = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.StatusAndFehlermeldungByEmailVorgang",
     query="UPDATE Email o SET o.status = ?2, o.fehlermeldung = ?3 WHERE o.emailVorgang = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.StatusByEmailVorgangAndStatus",
     query="UPDATE Email o SET o.status = ?3 WHERE o.emailVorgang = ?1 AND o.status = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="EMAIL.Status",
     query="select o from Email o where o.emailVorgang.wahltermin.mandant=?1 AND o.status=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "EMAIL")
// @javax.persistence.IdClass(EmailPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class Email
extends AbstractEmail
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Email() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Email(Email original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "email_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Email")
    @javax.persistence.TableGenerator(name = "Email", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Email", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient EmailPK pkCache;

  @Override
  public EmailPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new EmailPK(getId());
    }

    return pkCache;
  }

  public static <E extends Email> java.util.Map<EmailPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<EmailPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Email> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedAnzahlSendeversuche = false;
          hasChangedEmpfaenger = false;
          hasChangedFehlermeldung = false;
          hasChangedInhalt = false;
          hasChangedLetzterSendeversuch = false;
          hasChangedStatus = false;
  
      hasChangedEmailVorgang = false;
        hasChangedPersonendaten = false;
  
          hasChangedDateis = false;
      

    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "ANZAHL_SENDEVERSUCHE", nullable = EmailConstants.ANZAHL_SENDEVERSUCHE_NULLABLE, precision=EmailConstants.ANZAHL_SENDEVERSUCHE_PRECISION, scale=EmailConstants.ANZAHL_SENDEVERSUCHE_SCALE)
            
  protected java.lang.Long anzahlSendeversuche =  Long.valueOf("0");

  @javax.persistence.Transient
  protected boolean hasChangedAnzahlSendeversuche = false;

  public boolean hasChangedAnzahlSendeversuche(){
    return hasChangedAnzahlSendeversuche;
  }
  
  /**
   * 
   *
   * getter for EMAIL.ANZAHL_SENDEVERSUCHE
   */
    @Override   public  java.lang.Long getAnzahlSendeversuche() {
        return anzahlSendeversuche;
      }

  /**
   * 
   *
   * setter for EMAIL.ANZAHL_SENDEVERSUCHE
   *
   * @param anzahlSendeversuche
   */
  @Override   public void setAnzahlSendeversuche( java.lang.Long anzahlSendeversuche) {

       resetTkCache();
                  java.lang.Long anzahlSendeversucheInternal = anzahlSendeversuche;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzahlSendeversuche
      , anzahlSendeversucheInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzahlSendeversuche |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzahlSendeversuche");
      }


      

       this.anzahlSendeversuche = anzahlSendeversucheInternal;

         }

        
      @javax.persistence.Column(name = "EMPFAENGER", nullable = EmailConstants.EMPFAENGER_NULLABLE, length=EmailConstants.EMPFAENGER_MAX_LENGTH)
        
  protected java.lang.String empfaenger =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEmpfaenger = false;

  public boolean hasChangedEmpfaenger(){
    return hasChangedEmpfaenger;
  }
  
  /**
   * 
   *
   * getter for EMAIL.EMPFAENGER
   */
    @Override   public  java.lang.String getEmpfaenger() {
        return empfaenger;
      }

  /**
   * 
   *
   * setter for EMAIL.EMPFAENGER
   *
   * @param empfaenger
   */
  @Override   public void setEmpfaenger( java.lang.String empfaenger) {

       resetTkCache();
                  
                          java.lang.String empfaengerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(empfaenger, EmailConstants.EMPFAENGER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.empfaenger
      , empfaengerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEmpfaenger |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("empfaenger");
      }


      

       this.empfaenger = empfaengerInternal;

         }

        
  @javax.persistence.Column(name = "FEHLERMELDUNG", nullable = EmailConstants.FEHLERMELDUNG_NULLABLE, length=EmailConstants.FEHLERMELDUNG_MAX_LENGTH)
        
  protected java.lang.String fehlermeldung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedFehlermeldung = false;

  public boolean hasChangedFehlermeldung(){
    return hasChangedFehlermeldung;
  }
  
  /**
   * 
   *
   * getter for EMAIL.FEHLERMELDUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getFehlermeldung() {
        return fehlermeldung;
      }

  /**
   * 
   *
   * setter for EMAIL.FEHLERMELDUNG
   *
   * @param fehlermeldung
   */
  @Override   public void setFehlermeldung(@javax.annotation.Nullable  java.lang.String fehlermeldung) {

       resetTkCache();
                  
                          java.lang.String fehlermeldungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(fehlermeldung, EmailConstants.FEHLERMELDUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.fehlermeldung
      , fehlermeldungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedFehlermeldung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("fehlermeldung");
      }


      

       this.fehlermeldung = fehlermeldungInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
      @javax.persistence.Column(name = "INHALT", nullable = EmailConstants.INHALT_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String inhalt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedInhalt = false;

  public boolean hasChangedInhalt(){
    return hasChangedInhalt;
  }
  
  /**
   * 
   *
   * getter for EMAIL.INHALT
   *
   * (LAZY LOADING)
   */
    @Override   public  java.lang.String getInhalt() {
        return inhalt;
      }

  /**
   * 
   *
   * setter for EMAIL.INHALT
   *
   * @param inhalt
   */
  @Override   public void setInhalt( java.lang.String inhalt) {

       resetTkCache();
                  java.lang.String inhaltInternal = org.apache.commons.lang3.StringUtils.trimToNull(inhalt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.inhalt
      , inhaltInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedInhalt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("inhalt");
      }


      

       this.inhalt = inhaltInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "LETZTER_SENDEVERSUCH", nullable = EmailConstants.LETZTER_SENDEVERSUCH_NULLABLE, precision=EmailConstants.LETZTER_SENDEVERSUCH_PRECISION)
    
  protected java.util.Date letzterSendeversuch =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLetzterSendeversuch = false;

  public boolean hasChangedLetzterSendeversuch(){
    return hasChangedLetzterSendeversuch;
  }
  
  /**
   * 
   *
   * getter for EMAIL.LETZTER_SENDEVERSUCH
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getLetzterSendeversuch() {
              if (letzterSendeversuch == null){
            return null;
          } else {
                          return letzterSendeversuch;
          }
      }

  /**
   * 
   *
   * setter for EMAIL.LETZTER_SENDEVERSUCH
   *
   * @param letzterSendeversuch
   */
  @Override   public void setLetzterSendeversuch(@javax.annotation.Nullable  java.util.Date letzterSendeversuch) {

       resetTkCache();
                  java.util.Date letzterSendeversuchInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(letzterSendeversuch);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.letzterSendeversuch
      , letzterSendeversuchInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLetzterSendeversuch |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("letzterSendeversuch");
      }


      

       this.letzterSendeversuch = letzterSendeversuchInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = EmailConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.email.entity.EmailStatusType status =  de.ivu.elect.business.email.entity.EmailStatusType.ZU_VERSENDEN;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
  
  /**
   * 
   *
   * getter for EMAIL.STATUS
   */
    @Override   public  de.ivu.elect.business.email.entity.EmailStatusType getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for EMAIL.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.email.entity.EmailStatusType status) {

       resetTkCache();
                  de.ivu.elect.business.email.entity.EmailStatusType statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


      

       this.status = statusInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu EmailVorgang
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "EMAIL_VORGANG_ID", referencedColumnName="EMAIL_VORGANG_ID"))
  protected de.ivu.elect.business.email.entity.EmailVorgang emailVorgang;

  /**
   * 
   */
  @Override
  public void setEmailVorgang( de.ivu.elect.business.email.entity.EmailVorgang emailVorgang){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.emailVorgang
    , emailVorgang);

    attributeChanged |= thisAttributChanged;

    hasChangedEmailVorgang |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("emailVorgang");
    }

    this.emailVorgang = emailVorgang;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.email.entity.EmailVorgang getEmailVorgang(){
    return this.emailVorgang;
  }

  @javax.persistence.Transient
  protected boolean hasChangedEmailVorgang = false;

  public boolean hasChangedEmailVorgang(){
    return hasChangedEmailVorgang;
  }

  /**
   * Beziehung (unidirektional) zu Personendaten
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "PERSONENDATEN_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.person.entity.Personendaten personendaten;

  /**
   * 
   */
  @Override
  public void setPersonendaten(@javax.annotation.Nullable  de.ivu.elect.business.person.entity.Personendaten personendaten){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personendaten
    , personendaten);

    attributeChanged |= thisAttributChanged;

    hasChangedPersonendaten |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("personendaten");
    }

    this.personendaten = personendaten;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.person.entity.Personendaten getPersonendaten(){
    return this.personendaten;
  }

  @javax.persistence.Transient
  protected boolean hasChangedPersonendaten = false;

  public boolean hasChangedPersonendaten(){
    return hasChangedPersonendaten;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */
  /**
   * Beziehung N:M (bidirektional, nicht-fuehrend) zu Dateis
   */
  @javax.persistence.ManyToMany(mappedBy = "emails", fetch=javax.persistence.FetchType.LAZY)
  protected java.util.Set<de.ivu.elect.business.datei.entity.Datei> dateis;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.datei.entity.Datei> getDateis(){
    if (dateis == null){
      return  java.util.Collections.<de.ivu.elect.business.datei.entity.Datei>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.datei.entity.Datei>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.datei.entity.Datei>unmodifiableSet(this.dateis);
  }


  @javax.persistence.Transient
  private boolean hasChangedDateis = false;

  public boolean hasChangedDateis() {
    return hasChangedDateis;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.datei.entity.Datei
  */
  @Override
  public void addDatei(de.ivu.elect.business.datei.entity.Datei datei){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (datei != null){
          if (this.dateis == null){
            this.dateis = new java.util.HashSet<>();
          }

          boolean isChanged = this.dateis.add(datei);

          if(!hasChangedDateis) {
            hasChangedDateis =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          datei.addEmail(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.datei.entity.Datei
   */
  @Override
  public void removeDatei(de.ivu.elect.business.datei.entity.Datei datei){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (datei != null){
          if (this.dateis != null){
            boolean isChanged = this.dateis.remove(datei);

            if(!hasChangedDateis) {
              hasChangedDateis =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (datei != null) {
            datei.removeEmail(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.datei.entity.Datei
  */
   @Override
   public void removeAllDateis(){
     java.util.Set<de.ivu.elect.business.datei.entity.Datei> toRemove = new java.util.HashSet<>(getDateis());

     for (   de.ivu.elect.business.datei.entity.Datei entity:toRemove){
       removeDatei(entity);
     }
   }


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Email:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Email other){
                             other.anzahlSendeversuche = this.anzahlSendeversuche;
                                other.empfaenger = this.empfaenger;
                                other.fehlermeldung = this.fehlermeldung;
                                other.inhalt = this.inhalt;
                                other.letzterSendeversuch = this.letzterSendeversuch;
                                other.status = this.status;
           
  other.setEmailVorgang(this.getEmailVorgang());
  other.setPersonendaten(this.getPersonendaten());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Email.class)){
        copyEntityAttributesUsingSetter((Email) other.castTo(Email.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Email: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Email other){
               other.setAnzahlSendeversuche(this.anzahlSendeversuche);
                  other.setEmpfaenger(this.empfaenger);
                  other.setFehlermeldung(this.fehlermeldung);
                  other.setInhalt(this.inhalt);
                  other.setLetzterSendeversuch(this.letzterSendeversuch);
                  other.setStatus(this.status);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Email other){
                       if (hasChangedAnzahlSendeversuche) {
        other.setAnzahlSendeversuche(this.anzahlSendeversuche);
      }
                             if (hasChangedEmpfaenger) {
        other.setEmpfaenger(this.empfaenger);
      }
                             if (hasChangedFehlermeldung) {
        other.setFehlermeldung(this.fehlermeldung);
      }
                             if (hasChangedInhalt) {
        other.setInhalt(this.inhalt);
      }
                             if (hasChangedLetzterSendeversuch) {
        other.setLetzterSendeversuch(this.letzterSendeversuch);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
             }





    @javax.persistence.Transient
    private transient EmailTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public EmailTK getEmailTK(){
    if (tkCache==null) {
    tkCache = new EmailTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getEmailTK();
    }

  @Override
  public EmailUK getUk(){
    return getEmailUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Email.class;
  }

public EmailUK getEmailUK(){

   return  new EmailUK(



  );
}

  @javax.persistence.Transient
  private transient EmailProperties properties;

  public EmailProperties getProperties(){
    if (properties == null) {
      properties = new EmailProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public EmailProperties getEmailProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return EmailConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                         }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "EMAIL";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Email";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anzahlSendeversuche, this, EmailConstants.MESSAGE_KEY_ANZAHL_SENDEVERSUCHE_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(EmailConstants.ANZAHL_SENDEVERSUCHE_MAX_VALUE, EmailConstants.ANZAHL_SENDEVERSUCHE_MIN_VALUE, anzahlSendeversuche, this, EmailConstants.MESSAGE_KEY_ANZAHL_SENDEVERSUCHE_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(empfaenger, this, EmailConstants.MESSAGE_KEY_EMPFAENGER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailConstants.EMPFAENGER_MAX_LENGTH , 1 ,  empfaenger, this, EmailConstants.MESSAGE_KEY_EMPFAENGER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailConstants.FEHLERMELDUNG_MAX_LENGTH ,  fehlermeldung, this, EmailConstants.MESSAGE_KEY_FEHLERMELDUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(inhalt, this, EmailConstants.MESSAGE_KEY_INHALT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailConstants.INHALT_MAX_LENGTH , 1 ,  inhalt, this, EmailConstants.MESSAGE_KEY_INHALT_EINZAHL, validationResult);
                                                                                                                    de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, EmailConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
